--Legal Notice: (C)2007 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity audio is 
        port (
              -- inputs:
                 signal avs_s1_address : IN STD_LOGIC;
                 signal avs_s1_chipselect : IN STD_LOGIC;
                 signal avs_s1_clk : IN STD_LOGIC;
                 signal avs_s1_read : IN STD_LOGIC;
                 signal avs_s1_reset_n : IN STD_LOGIC;
                 signal avs_s1_write : IN STD_LOGIC;
                 signal avs_s1_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal avs_s1_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal freq : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal mod_depth : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal on_off : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );
end entity audio;


architecture europa of audio is
component audio_peripheral is 
           port (
                 -- inputs:
                    signal avs_s1_address : IN STD_LOGIC;
                    signal avs_s1_chipselect : IN STD_LOGIC;
                    signal avs_s1_clk : IN STD_LOGIC;
                    signal avs_s1_read : IN STD_LOGIC;
                    signal avs_s1_reset_n : IN STD_LOGIC;
                    signal avs_s1_write : IN STD_LOGIC;
                    signal avs_s1_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal avs_s1_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal freq : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal mod_depth : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal on_off : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component audio_peripheral;

                signal internal_avs_s1_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_freq :  STD_LOGIC_VECTOR (15 DOWNTO 0);
                signal internal_mod_depth :  STD_LOGIC_VECTOR (3 DOWNTO 0);
                signal internal_on_off :  STD_LOGIC_VECTOR (15 DOWNTO 0);

begin

  --the_audio_peripheral, which is an e_instance
  the_audio_peripheral : audio_peripheral
    port map(
      avs_s1_readdata => internal_avs_s1_readdata,
      freq => internal_freq,
      mod_depth => internal_mod_depth,
      on_off => internal_on_off,
      avs_s1_address => avs_s1_address,
      avs_s1_chipselect => avs_s1_chipselect,
      avs_s1_clk => avs_s1_clk,
      avs_s1_read => avs_s1_read,
      avs_s1_reset_n => avs_s1_reset_n,
      avs_s1_write => avs_s1_write,
      avs_s1_writedata => avs_s1_writedata
    );


  --vhdl renameroo for output signals
  avs_s1_readdata <= internal_avs_s1_readdata;
  --vhdl renameroo for output signals
  freq <= internal_freq;
  --vhdl renameroo for output signals
  mod_depth <= internal_mod_depth;
  --vhdl renameroo for output signals
  on_off <= internal_on_off;

end europa;

